#
# Defines OR-Join semantics
#
require 'piexecutor.rb'
require 'pianalyzer.rb'

def quick_or_join(active_nodes, parser = nil, sel = 0)

	return [] if !active_nodes

	active = active_nodes.clone
	blocked = []

	# Select blocked transitions
	active.each do |n|	
		if n.class == IntraactionNodes and n.input.value.object.include?('or_done')
				blocked << n
			end
		end
		
	# Delete all blocked transitions from the active set
	blocked.each do |n|
			active.delete(n)
		end
				
	# Check if only blocked transitions, if so enable them all
	if active.size == 0
		active = blocked.clone
		blocked = []
		end
								
	# Block only IF	\exists n \in active => \exists path from n to JOIN
	blocked.each do |b|
		keep_blocked = false				
		# Get node if of blocked join
		target_id = b.input.value.function.sub(/N[0-9]*_/,'')
		# Iterate over all active nodes 
		active.each do |a|
			source_id = 0
			# Check if there is a path between source_id and target_id
			case a
				when Node:
					# Get id from tau
					source_id = a.value.function.sub(/N[0-9]*_/,'')
				when IntraactionNodes:
					# Get id from XML
					tmp_id = parser.xml.elements.to_a("/model/process[@id='#{sel}']/flow[@id='#{a.input.value.object.sub(/e/,'').to_i.to_s}']")
					if tmp_id && tmp_id[0]
						source_id = tmp_id[0].attributes['to'] 
						else
						# Get id from function
						source_id = a.input.value.function.sub(/N[0-9]*_/,'')
						end
				else
					raise "Unkown node type!"
				end
			# If path exists, set keep_blocked to true
			source_index = parser.analyzers[sel-1].nodeIds.index(source_id)
			target_index = parser.analyzers[sel-1].nodeIds.index(target_id)		
			keep_blocked = true if parser.analyzers[sel-1].tcMatrix[source_index][target_index] < 9999
			keep_blocked = true if source_id == target_id # Reflexive behavior							
			end
		
		# Move entry from blocked to active if required
		if !keep_blocked 
			active << b
			blocked.delete(b)
			end
		
		end if parser
			
		return active, blocked
					
end